# SaveMagMorphs.py
# 5/21/04, by Ockham (David G. Drumright)
# 11/11/05 added new FBM action for P6 SR2
#
# -------------------
from Tkinter import *
import tkFileDialog
import os
import poser
scene=poser.Scene()
try:
    TheFig=scene.CurrentFigure()
except:
    TheFig=0

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Save Mags as Morphs")
        # Lists
        self.ListScroll = Scrollbar(self.master, orient=VERTICAL)
        self.ListScroll.grid( row=2, column=0,sticky=N+S+E)
        self.List = Listbox(self.master, height=5, selectmode=MULTIPLE,yscrollcommand = self.ListScroll.set)
        self.List.grid( row=2, column=1)
        # Set the scrollbar to work
        self.ListScroll["command"] = self.List.yview
        # Fill the list with only the parts that have mags.
        if TheFig:
            for TryPart in TheFig.Actors():
                if TryPart.IsBase(): # this is a base
                    OneActor=TryPart.Parent()
                    ActorName=OneActor.Name()
                    self.List.insert(END,ActorName)
        else: # Just props
            for TryPart in scene.Actors():
                if TryPart.IsBase(): # this is a base
                    OneActor=TryPart.Parent()
                    ActorName=OneActor.Name()
                    self.List.insert(END,ActorName)

        # Go/nogo buttons.
        self.buttonGo = Button(self.master, text="Go", command=self.HandleGo)
        self.buttonGo.grid(row=3, column=0, padx=10)

        self.buttonCancel = Button(self.master, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=3, column=2,padx=10)

        # NEW: Exit cleanly
        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents()
        root.lift()
        root.after(250, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def DoMorphs(self,ActorName):
        # See if just spawning does the job.  I know it won't.
        TheActor=scene.Actor(ActorName)
        MorphName="MagMorph"
        TheActor.SpawnTarget(MorphName)  # Now create the new
        NewParm = TheActor.Parameter(MorphName) # Fetch the new parm (Spawn doesn't return anything)
        NewParm.SetValue(0.0)

        # Delete the magnets on this actor
        for TryBase in TheActor.Children():
            if TryBase.IsBase(): # this is a base
                scene.SelectActor(TryBase)
                scene.DeleteCurrentProp()

    # - - - - - - - - - - - - - - - - - -

    def HandleGo(self):
        # Go through the selections.
        Sels=self.List.curselection()
        if not Sels:  # Do all in list
            for OneIndex in range(self.List.size()):
                ActorName=self.List.get(OneIndex)
                self.DoMorphs(ActorName)
        else: # Sels
            for OneIndex in Sels:
                ActorName=self.List.get(int(OneIndex))
                self.DoMorphs(ActorName)

        # New for P6 SR2: finally have a FBM function.
        if TheFig:
            for Actor in TheFig.Actors():
                try:
                    Actor.Parameter("MagMorph").SetValue(1.0) # Put 1.0
                except:
                    continue  # actor has no MagMorph
            # Now that the morphs are up, make the FBM
            try:
                TheFig.CreateFullBodyMorph("AllMags")
            except:
                pass
            for Actor in TheFig.Actors():
                try:
                    Actor.Parameter("MagMorph").SetValue(0.0) # Return to zero
                except:
                    continue  # actor has no MagMorph
        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
